`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/15 19:48:32
// Design Name: 
// Module Name: ASCII_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define ASCII_KEY_A 9'h01c
`define ASCII_KEY_B 9'h032
`define ASCII_KEY_C 9'h021
`define ASCII_KEY_D 9'h023
`define ASCII_KEY_E 9'h024
`define ASCII_KEY_F 9'h02b
`define ASCII_KEY_G 9'h034
`define ASCII_KEY_H 9'h033
`define ASCII_KEY_I 9'h043
`define ASCII_KEY_J 9'h03b
`define ASCII_KEY_K 9'h042
`define ASCII_KEY_L 9'h04b
`define ASCII_KEY_M 9'h03a
`define ASCII_KEY_N 9'h031
`define ASCII_KEY_O 9'h044
`define ASCII_KEY_P 9'h04d
`define ASCII_KEY_Q 9'h015
`define ASCII_KEY_R 9'h02d
`define ASCII_KEY_S 9'h01b
`define ASCII_KEY_T 9'h02c
`define ASCII_KEY_U 9'h03c
`define ASCII_KEY_V 9'h02a
`define ASCII_KEY_W 9'h01d
`define ASCII_KEY_X 9'h022
`define ASCII_KEY_Y 9'h035
`define ASCII_KEY_Z 9'h01a



//UPPERCASE
`define ASCII_A 7'd65
`define ASCII_B 7'd66
`define ASCII_C 7'd67
`define ASCII_D 7'd68
`define ASCII_E 7'd69
`define ASCII_F 7'd70
`define ASCII_G 7'd71
`define ASCII_H 7'd72
`define ASCII_I 7'd73
`define ASCII_J 7'd74
`define ASCII_K 7'd75
`define ASCII_L 7'd76
`define ASCII_M 7'd77
`define ASCII_N 7'd78
`define ASCII_O 7'd79
`define ASCII_P 7'd80
`define ASCII_Q 7'd81
`define ASCII_R 7'd82
`define ASCII_S 7'd83
`define ASCII_T 7'd84
`define ASCII_U 7'd85
`define ASCII_V 7'd86
`define ASCII_W 7'd87
`define ASCII_X 7'd88
`define ASCII_Y 7'd89
`define ASCII_Z 7'd90

//LOWERCASE
`define ASCII_a 7'd97
`define ASCII_b 7'd98
`define ASCII_c 7'd99
`define ASCII_d 7'd100
`define ASCII_e 7'd101
`define ASCII_f 7'd102
`define ASCII_g 7'd103
`define ASCII_h 7'd104
`define ASCII_i 7'd105
`define ASCII_j 7'd106
`define ASCII_k 7'd107
`define ASCII_l 7'd108
`define ASCII_m 7'd109
`define ASCII_n 7'd110
`define ASCII_o 7'd111
`define ASCII_p 7'd112
`define ASCII_q 7'd113
`define ASCII_r 7'd114
`define ASCII_s 7'd115
`define ASCII_t 7'd116
`define ASCII_u 7'd117
`define ASCII_v 7'd118
`define ASCII_w 7'd119
`define ASCII_x 7'd120
`define ASCII_y 7'd121
`define ASCII_z 7'd122

`define LEFT_SHIFT 9'h012
`define RIGHT_SHIFT 9'h059

module ASCII_decoder(
    ASCII_code, 
    key_down,
    last_change,
    caps_lock,
    rst
    );

    output reg [6:0] ASCII_code;
    input [511:0] key_down;
    input [8:0] last_change;
    input caps_lock;
    input rst;

    reg [6:0] next_ASCII_code;
    
    always @*
        if ((~caps_lock) && ~(key_down[`LEFT_SHIFT] || key_down[`RIGHT_SHIFT]) || (caps_lock) && (key_down[`LEFT_SHIFT] || key_down[`RIGHT_SHIFT]))
            case (last_change)
            `ASCII_KEY_A:
                next_ASCII_code = `ASCII_a;
            `ASCII_KEY_B:
                next_ASCII_code = `ASCII_b;
            `ASCII_KEY_C:
                next_ASCII_code = `ASCII_c;
            `ASCII_KEY_D:
                next_ASCII_code = `ASCII_d;
            `ASCII_KEY_E:
                next_ASCII_code = `ASCII_e;
            `ASCII_KEY_F:
                next_ASCII_code = `ASCII_f;
            `ASCII_KEY_G:
                next_ASCII_code = `ASCII_g;
            `ASCII_KEY_H:
                next_ASCII_code = `ASCII_h;
            `ASCII_KEY_I:
                next_ASCII_code = `ASCII_i;
            `ASCII_KEY_J:
                next_ASCII_code = `ASCII_j;
            `ASCII_KEY_K:
                next_ASCII_code = `ASCII_k;
            `ASCII_KEY_L:
                next_ASCII_code = `ASCII_l;
            `ASCII_KEY_M:
                next_ASCII_code = `ASCII_m;
            `ASCII_KEY_N:
                next_ASCII_code = `ASCII_n;
            `ASCII_KEY_O:
                next_ASCII_code = `ASCII_o;
            `ASCII_KEY_P:
                next_ASCII_code = `ASCII_p;
            `ASCII_KEY_Q:
                next_ASCII_code = `ASCII_q;
            `ASCII_KEY_R:
                next_ASCII_code = `ASCII_r;
            `ASCII_KEY_S:
                next_ASCII_code = `ASCII_s;
            `ASCII_KEY_T:
                next_ASCII_code = `ASCII_t;
            `ASCII_KEY_U:
                next_ASCII_code = `ASCII_u;
            `ASCII_KEY_V:
                next_ASCII_code = `ASCII_v;
            `ASCII_KEY_W:
                next_ASCII_code = `ASCII_w;
            `ASCII_KEY_X:
                next_ASCII_code = `ASCII_x;
            `ASCII_KEY_Y:
                next_ASCII_code = `ASCII_y;
            `ASCII_KEY_Z:
                next_ASCII_code = `ASCII_z;
            default:
                next_ASCII_code = 7'd0;
            endcase
        else
            case (last_change)
            `ASCII_KEY_A:
                next_ASCII_code = `ASCII_A;
            `ASCII_KEY_B:
                next_ASCII_code = `ASCII_B;
            `ASCII_KEY_C:
                next_ASCII_code = `ASCII_C;
            `ASCII_KEY_D:
                next_ASCII_code = `ASCII_D;
            `ASCII_KEY_E:
                next_ASCII_code = `ASCII_E;
            `ASCII_KEY_F:
                next_ASCII_code = `ASCII_F;
            `ASCII_KEY_G:
                next_ASCII_code = `ASCII_G;
            `ASCII_KEY_H:
                next_ASCII_code = `ASCII_H;
            `ASCII_KEY_I:
                next_ASCII_code = `ASCII_I;
            `ASCII_KEY_J:
                next_ASCII_code = `ASCII_J;
            `ASCII_KEY_K:
                next_ASCII_code = `ASCII_K;
            `ASCII_KEY_L:
                next_ASCII_code = `ASCII_L;
            `ASCII_KEY_M:
                next_ASCII_code = `ASCII_M;
            `ASCII_KEY_N:
                next_ASCII_code = `ASCII_N;
            `ASCII_KEY_O:
                next_ASCII_code = `ASCII_O;
            `ASCII_KEY_P:
                next_ASCII_code = `ASCII_P;
            `ASCII_KEY_Q:
                next_ASCII_code = `ASCII_Q;
            `ASCII_KEY_R:
                next_ASCII_code = `ASCII_R;
            `ASCII_KEY_S:
                next_ASCII_code = `ASCII_S;
            `ASCII_KEY_T:
                next_ASCII_code = `ASCII_T;
            `ASCII_KEY_U:
                next_ASCII_code = `ASCII_U;
            `ASCII_KEY_V:
                next_ASCII_code = `ASCII_V;
            `ASCII_KEY_W:
                next_ASCII_code = `ASCII_W;
            `ASCII_KEY_X:
                next_ASCII_code = `ASCII_X;
            `ASCII_KEY_Y:
                next_ASCII_code = `ASCII_Y;
            `ASCII_KEY_Z:
                next_ASCII_code = `ASCII_Z;
            default:
                next_ASCII_code = 7'd0;
            endcase

    always @(posedge key_down[last_change] or posedge rst)
        if (rst)
            ASCII_code <= 7'd0;
        else
            ASCII_code <= next_ASCII_code;
    
endmodule




