`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/12 16:30:11
// Design Name: 
// Module Name: topmodule
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module topmodule(
    LED_out,
    clk,
    rst,
    PS2_DATA,
    PS2_CLK
    );

    output [6:0] LED_out;
    
    input clk;
    input rst;

    inout PS2_CLK;
    inout PS2_DATA;
    
    wire [511:0] key_down;
    wire [8:0] last_change;
    wire key_valid;
    wire caps_lock;

    wire valid_signal;

    assign valid_signal = key_down[last_change];


    KeyboardDecoder U0(
	.key_down(key_down),
	.last_change(last_change),
	.key_valid(key_valid),
	.PS2_DATA(PS2_DATA),
	.PS2_CLK(PS2_CLK),
	.rst(rst),
	.clk(clk)
    );
    
    fsm U1(
    .last_change(last_change),
    .valid(valid_signal),
    .curr_state(caps_lock),
    .rst(rst)
);
    ASCII_decoder U2(
    .ASCII_code(LED_out), 
    .key_down(key_down),
    .last_change(last_change),
    .caps_lock(caps_lock),
    .rst(rst)
    );

endmodule
